/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSClusterControllerIdentityLister helps list AWSClusterControllerIdentities.
// All objects returned here must be treated as read-only.
type AWSClusterControllerIdentityLister interface {
	// List lists all AWSClusterControllerIdentities in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSClusterControllerIdentity, err error)
	// AWSClusterControllerIdentities returns an object that can list and get AWSClusterControllerIdentities.
	AWSClusterControllerIdentities(namespace string) AWSClusterControllerIdentityNamespaceLister
	AWSClusterControllerIdentityListerExpansion
}

// aWSClusterControllerIdentityLister implements the AWSClusterControllerIdentityLister interface.
type aWSClusterControllerIdentityLister struct {
	indexer cache.Indexer
}

// NewAWSClusterControllerIdentityLister returns a new AWSClusterControllerIdentityLister.
func NewAWSClusterControllerIdentityLister(indexer cache.Indexer) AWSClusterControllerIdentityLister {
	return &aWSClusterControllerIdentityLister{indexer: indexer}
}

// List lists all AWSClusterControllerIdentities in the indexer.
func (s *aWSClusterControllerIdentityLister) List(selector labels.Selector) (ret []*v1beta2.AWSClusterControllerIdentity, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSClusterControllerIdentity))
	})
	return ret, err
}

// AWSClusterControllerIdentities returns an object that can list and get AWSClusterControllerIdentities.
func (s *aWSClusterControllerIdentityLister) AWSClusterControllerIdentities(namespace string) AWSClusterControllerIdentityNamespaceLister {
	return aWSClusterControllerIdentityNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AWSClusterControllerIdentityNamespaceLister helps list and get AWSClusterControllerIdentities.
// All objects returned here must be treated as read-only.
type AWSClusterControllerIdentityNamespaceLister interface {
	// List lists all AWSClusterControllerIdentities in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSClusterControllerIdentity, err error)
	// Get retrieves the AWSClusterControllerIdentity from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSClusterControllerIdentity, error)
	AWSClusterControllerIdentityNamespaceListerExpansion
}

// aWSClusterControllerIdentityNamespaceLister implements the AWSClusterControllerIdentityNamespaceLister
// interface.
type aWSClusterControllerIdentityNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AWSClusterControllerIdentities in the indexer for a given namespace.
func (s aWSClusterControllerIdentityNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.AWSClusterControllerIdentity, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSClusterControllerIdentity))
	})
	return ret, err
}

// Get retrieves the AWSClusterControllerIdentity from the indexer for a given namespace and name.
func (s aWSClusterControllerIdentityNamespaceLister) Get(name string) (*v1beta2.AWSClusterControllerIdentity, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awsclustercontrolleridentity"), name)
	}
	return obj.(*v1beta2.AWSClusterControllerIdentity), nil
}
